#! /bin/awk -f

#####
#
# pyMath00.awk
# MDJ 2022/03/27
#
# Use this program only for:
#   AdditionData00
#   AdvAddData00
#   AdvMultData00
#   AdvSubData00
#   MultiplyData00
#   SubtractData00
#
# Python Version Step Four:
#   Copy wk00/dataout
#   to wk02/dataout
#   while adding the
#   Prequestion Line 
#   to each block; and
#   then translating the
#   Question and Answer
#   Lines as well.
#
# To Run:
#   cdCoCo
#   cd wk00
#   pyMath00.awk dataout
#
# After completion of run, copy
#   /wk02/dataout to final file
#     /wk02/AdditionData02,
#     /wk02/AdvAddData02,
#     /wk02/AdvMult02,
#     /wk02/AdvSubData02,
#     /wk02/MultiplyData02,or
#     /wk02/SubtractData02, 
#     as appropriate.
#
#####

BEGIN {
	BNn = 0   # Block Number Counter
	BN = "00" # Block Number Counter Display
	# Prequestion Line:
	PQL = "What is the result:"
	# Array Line Fragments
	ALA = "AStr["
	ALB = "]["
	ALC = "]"
	print " "
	print "Start Step Four pyMath Xfer"
	print " "
}

{

	# First Block
	# First Line of Block
	#  = Question Number Comment Line

	# Truncate $NF to remove trailing "\n"
	NFT = substr($NF,1,2)
	
	# Convert NFT string to numeric
	NFn = 0 + NFT
	
	# Convert BNn Counter to string
	if ( BNn < 10 )
	{
		BN = "0" BNn
	}
	else
	{
		BN = "" BNn
	}
	
	if ( NFn == BNn )
	{
		print "Match " BN " " NFT
		print $0
		print $0 > "../wk02/dataout"
		PQLA = "AStr[" BNn "][0] = \"" PQL "\""
		print PQLA
		print PQLA >> "../wk02/dataout"
	}
	else
	{
		print "No Match " BN " " NFT " ERROR!"
		print $0
		exit 1
	}
	
	# Question Line
	getline
	$1 = ALA BNn ALB "1" ALC
	$2 = "="
	len = length($NF)
	$NF = substr($NF,1,len-1)
	if (NF == 3)
	{
		$NF = "\"" $NF " ?\""
	}
	else
	{
		$3 = "\"" $3
		$NF = $NF " ?\""
	}
	print $0
	print $0 >> "../wk02/dataout"
	
	# Correct Answer Line
	getline
	$1 = ALA BNn ALB "2" ALC
	$2 = "="
	len = length($NF)
	$NF = substr($NF,1,len-1)
	if (NF == 3)
	{
		if (substr($NF,1,1) != "\"")
		{
			$NF = "\"" $NF "\""
		}
	}
	else
	{
		$3 = "\"" $3
		$NF = $NF "\""
	}
	print $0
	print $0 >> "../wk02/dataout"
	
	# Incorrect Answer #1 Line
	getline
	$1 = ALA BNn ALB "3" ALC
	$2 = "="
	len = length($NF)
	$NF = substr($NF,1,len-1)
	if (NF == 3)
	{
		if (substr($NF,1,1) != "\"")
		{
			$NF = "\"" $NF "\""
		}
	}
	else
	{
		$3 = "\"" $3
		$NF = $NF "\""
	}
	print $0
	print $0 >> "../wk02/dataout"
	
	# Incorrect Answer #2 Line
	getline
	$1 = ALA BNn ALB "4" ALC
	$2 = "="
	len = length($NF)
	$NF = substr($NF,1,len-1)
	if (NF == 3)
	{
		if (substr($NF,1,1) != "\"")
		{
			$NF = "\"" $NF "\""
		}
	}
	else
	{
		$3 = "\"" $3
		$NF = $NF "\""
	}
	print $0
	print $0 >> "../wk02/dataout"
	
	# Incorrect Answer #3 Line
	getline
	$1 = ALA BNn ALB "5" ALC
	$2 = "="
	len = length($NF)
	$NF = substr($NF,1,len-1)
	if (NF == 3)
	{
		if (substr($NF,1,1) != "\"")
		{
			$NF = "\"" $NF "\""
		}
	}
	else
	{
		$3 = "\"" $3
		$NF = $NF "\""
	}
	print $0
	print $0 >> "../wk02/dataout"
	
	# Incorrect Answer #4 Line
	getline
	$1 = ALA BNn ALB "6" ALC
	$2 = "="
	len = length($NF)
	$NF = substr($NF,1,len-1)
	if (NF == 3)
	{
		if (substr($NF,1,1) != "\"")
		{
			$NF = "\"" $NF "\""
		}
	}
	else
	{
		$3 = "\"" $3
		$NF = $NF "\""
	}
	print $0
	print $0 >> "../wk02/dataout"
	
	# Blank Line
	getline
	print $0
	print $0 >> "../wk02/dataout"
	
	# Blocks 2 through last:
	# Question Number Comment Line
	while ( 1 == 1 )
	{
		r = getline
		# If EOF:
		if (r <= 0)
		{
			exit 0
		}
		else
		{
			BNn = BNn + 1
	
			# Truncate $NF to remove trailing "\n"
			NFT = substr($NF,1,2)
	
			# Convert NFT string to numeric
			NFn = 0 + NFT
	
			# Convert BNn Counter to string
			if ( BNn < 10 )
			{
				BN = "0" BNn
			}
			else
			{
				BN = "" BNn
			}
		
			if ( NFn == BNn )
			{
				print "Match " BN " " NFT
				print $0
				print $0 >> "../wk02/dataout"
				PQLA = "AStr[" BNn "][0] = \"" PQL "\""
				print PQLA
				print PQLA >> "../wk02/dataout"
			}
			else
			{
				print "No Match " BN " " NFT " ERROR!"
				print $0
				exit 1
			}
		}
		
		# Question Line
		getline
		$1 = ALA BNn ALB "1" ALC
		$2 = "="
		len = length($NF)
		$NF = substr($NF,1,len-1)
		if (NF == 3)
		{
			$NF = "\"" $NF " ?\""
		}
		else
		{
			$3 = "\"" $3
			$NF = $NF " ?\""
		}
		print $0
		print $0 >> "../wk02/dataout"
		
		# Correct Answer Line
		getline
		$1 = ALA BNn ALB "2" ALC
		$2 = "="
		len = length($NF)
		$NF = substr($NF,1,len-1)
		if (NF == 3)
		{
			if (substr($NF,1,1) != "\"")
			{
				$NF = "\"" $NF "\""
			}
		}
		else
		{
			$3 = "\"" $3
			$NF = $NF "\""
		}
		print $0
		print $0 >> "../wk02/dataout"
		
		# Incorrect Answer #1 Line
		getline
		$1 = ALA BNn ALB "3" ALC
		$2 = "="
		len = length($NF)
		$NF = substr($NF,1,len-1)
		if (NF == 3)
		{
			if (substr($NF,1,1) != "\"")
			{
				$NF = "\"" $NF "\""
			}
		}
		else
		{
			$3 = "\"" $3
			$NF = $NF "\""
		}
		print $0
		print $0 >> "../wk02/dataout"
		
		# Incorrect Answer #2 Line
		getline
		$1 = ALA BNn ALB "4" ALC
		$2 = "="
		len = length($NF)
		$NF = substr($NF,1,len-1)
		if (NF == 3)
		{
			if (substr($NF,1,1) != "\"")
			{
				$NF = "\"" $NF "\""
			}
		}
		else
		{
			$3 = "\"" $3
			$NF = $NF "\""
		}
		print $0
		print $0 >> "../wk02/dataout"
		
		# Incorrect Answer #3 Line
		getline
		$1 = ALA BNn ALB "5" ALC
		$2 = "="
		len = length($NF)
		$NF = substr($NF,1,len-1)
		if (NF == 3)
		{
			if (substr($NF,1,1) != "\"")
			{
				$NF = "\"" $NF "\""
			}
		}
		else
		{
			$3 = "\"" $3
			$NF = $NF "\""
		}
		print $0
		print $0 >> "../wk02/dataout"
		
		# Incorrect Answer #4 Line
		getline
		$1 = ALA BNn ALB "6" ALC
		$2 = "="
		len = length($NF)
		$NF = substr($NF,1,len-1)
		if (NF == 3)
		{
			if (substr($NF,1,1) != "\"")
			{
				$NF = "\"" $NF "\""
			}
		}
		else
		{
			$3 = "\"" $3
			$NF = $NF "\""
		}
		print $0
		print $0 >> "../wk02/dataout"
		
		# Blank Line
		getline
		print $0
		print $0 >> "../wk02/dataout"
	}
}

END { 
	print "End of Step Four pyMath Xfer" 
	print " "
}

#####
#
# EOF
#
#####
